/*
 * Copyright 2006, U.S. Robotics Corporation
 * All Rights Reserved.
 * 
 * THIS SOFTWARE IS OFFERED "AS IS", AND U.S. Robotics GRANTS NO WARRANTIES OF
 * ANY KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. U.S.
 * Robotics SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
 *
 * $Id$
 */
/*
 * Miscellaneous services
 *
 * Copyright 2006, Broadcom Corporation
 * All Rights Reserved.
 * 
 * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
 * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
 * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
 *
 * $Id$
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <errno.h>

#include <bcmnvram.h>
#include <netconf.h>
#include <shutils.h>
#include <rc.h>

#define assert(a)

#ifdef __CONFIG_NAT__
/* not used yet
static char 
*make_var(char *prefix,int index,char *name)
{
	static char buf[100];
	
	assert(prefix);
	assert(name);
	
	if (index)
		snprintf(buf,sizeof(buf),"%s%d%s",prefix,index,name);
	else
		snprintf(buf,sizeof(buf),"%s%s",prefix,name);
	return buf;
}
*/
int
start_dhcpd(void)
{
	FILE *fp;
	char name[100], line[1500];
	/* not used yet
	char word[32], *next;
	char dhcp_conf_file[128];
	char dhcp_lease_file[128];
	char dhcp_ifnames[128];
	int index; */

	if (nvram_match("router_disable", "1") || nvram_invmatch("lan_proto", "dhcp") || nvram_match("router_disable_auto", "1"))
		return 0;
	
	/*not used yet
	// Setup individual dhcp severs for the bridge and the every unbridged interface 
	   
	snprintf(dhcp_ifnames,sizeof(dhcp_ifnames),"%s",nvram_safe_get("lan_ifname"));
	
	if (nvram_get("unbridged_ifnames"))
		foreach(word,nvram_safe_get("unbridged_ifnames"),next){

			snprintf(dhcp_ifnames,sizeof(dhcp_ifnames),
				"%s %s",dhcp_ifnames,word);
		}
	
	index=0;
	foreach(word, dhcp_ifnames, next){
	
		if (strstr(word,"br0") ) 
			index = 0 ;
		else
			index = get_ipconfig_index(word);
		
		// Skip interface if no valid config block is found 
		if (index < 0) continue;
		
		if (nvram_invmatch(make_var("lan",index,"_proto"),"dhcp"))
			continue;
			
		dprintf("%s %s %s %s\n",
			nvram_safe_get(make_var("lan",index,"_ifname")),
			nvram_safe_get(make_var("dhcp",index,"_start")),
			nvram_safe_get(make_var("dhcp",index,"_end")),
			nvram_safe_get(make_var("lan",index,"_lease")));

		// Touch leases file
		sprintf(dhcp_lease_file,"/tmp/udhcpd%d.leases",index);
		if (!(fp = fopen(dhcp_lease_file, "a"))) {
			perror(dhcp_lease_file);
			return errno;
		}
		fclose(fp);

		// Write configuration file based on current information
		sprintf(dhcp_conf_file,"/tmp/udhcpd%d.conf",index);
		if (!(fp = fopen(dhcp_conf_file, "w"))) {
			perror(dhcp_conf_file);
			return errno;
		}
		fprintf(fp, "pidfile /var/run/udhcpd%d.pid\n",index);
		fprintf(fp, "start %s\n", nvram_safe_get(make_var("dhcp",index,"_start")));
		fprintf(fp, "end %s\n", nvram_safe_get(make_var("dhcp",index,"_end")));
		fprintf(fp, "interface %s\n", word);
		fprintf(fp, "remaining yes\n");
		fprintf(fp, "lease_file /tmp/udhcpd%d.leases\n",index);
		fprintf(fp, "option subnet %s\n", nvram_safe_get(make_var("lan",index,"_netmask")));
		fprintf(fp, "option router %s\n", nvram_safe_get(make_var("lan",index,"_ipaddr")));
		fprintf(fp, "option dns %s\n", nvram_safe_get(make_var("lan",index,"_ipaddr")));
		fprintf(fp, "option lease %s\n", nvram_safe_get(make_var("lan",index,"_lease")));
		snprintf(name, sizeof(name), "%s_wins", nvram_safe_get(make_var("dhcp",index,"_wins")));
		if (nvram_invmatch(name, ""))
			fprintf(fp, "option wins %s\n", nvram_get(name));
		snprintf(name, sizeof(name), "%s_domain", nvram_safe_get(make_var("dhcp",index,"_domain")));
		if (nvram_invmatch(name, ""))
			fprintf(fp, "option domain %s\n", nvram_get(name));
		fclose(fp);

		eval("udhcpd", dhcp_conf_file);
		index++;
	}
	
	*/
	/* Touch leases file */
	if (!(fp = fopen("/tmp/udhcpd.leases", "a"))) {
		perror("/tmp/udhcpd.leases");
		return errno;
	}
	fclose(fp);

	/* Write configuration file based on current information */
	if (!(fp = fopen("/tmp/udhcpd.conf", "w"))) {
		perror("/tmp/udhcpd.conf");
		return errno;
	}
	fprintf(fp, "pidfile /var/run/udhcpd.pid\n");
	fprintf(fp, "start %s\n", nvram_safe_get("dhcp_start"));
	fprintf(fp, "end %s\n", nvram_safe_get("dhcp_end"));
	fprintf(fp, "interface %s\n", nvram_safe_get("lan_ifname"));
	fprintf(fp, "remaining yes\n");
	fprintf(fp, "lease_file /tmp/udhcpd.leases\n");
	fprintf(fp, "option subnet %s\n", nvram_safe_get("lan_netmask"));
	fprintf(fp, "option router %s\n", nvram_safe_get("lan_ipaddr"));
	fprintf(fp, "option dns %s\n", nvram_safe_get("lan_ipaddr"));
	fprintf(fp, "option lease %s\n", nvram_safe_get("lan_lease"));
	snprintf(name, sizeof(name), "%s_wins", nvram_safe_get("dhcp_wins"));
	if (nvram_invmatch(name, ""))
		fprintf(fp, "option wins %s\n", nvram_get(name));
	snprintf(name, sizeof(name), "%s_domain", nvram_safe_get("dhcp_domain"));
	if (nvram_invmatch(name, ""))
		fprintf(fp, "option domain %s\n", nvram_get(name));
#ifndef ROUTER
	char *mac_string, *ip_string;
	snprintf(line, sizeof(line), "%s", nvram_safe_get("static_lease"));
	if ( strlen(line) ) {	
		mac_string = strtok(line, " \t");
		ip_string = strtok(NULL, " \t");
		fprintf(fp, "static_lease %s %s\n", mac_string, ip_string);
		while (mac_string != NULL) {
			mac_string = strtok(NULL, " \t");
			if (mac_string == NULL)
				break;
			ip_string = strtok(NULL, " \t");
			if (ip_string == NULL)
				break;
			fprintf(fp, "static_lease %s %s\n", mac_string, ip_string);
		}
	}
#endif /* ROUTER */

	fclose(fp);

	eval("udhcpd", "/tmp/udhcpd.conf");

	dprintf("done\n");
	return 0;
}

int
stop_dhcpd(void)
{
	char sigusr1[] = "-XX";
	int ret;

/*
* Process udhcpd handles two signals - SIGTERM and SIGUSR1
*
*  - SIGUSR1 saves all leases in /tmp/udhcpd.leases
*  - SIGTERM causes the process to be killed
*
* The SIGUSR1+SIGTERM behavior is what we like so that all current client
* leases will be honorred when the dhcpd restarts and all clients can extend
* their leases and continue their current IP addresses. Otherwise clients
* would get NAK'd when they try to extend/rebind their leases and they 
* would have to release current IP and to request a new one which causes 
* a no-IP gap in between.
*/
	sprintf(sigusr1, "-%d", SIGUSR1);
	eval("killall", sigusr1, "udhcpd");
	ret = eval("killall", "udhcpd");

	dprintf("done\n");
	return ret;
}
#endif	/* __CONFIG_NAT__ */

int
start_dns(void)
{
	int ret;
	FILE *fp;
	/* not used yet
	char word[32], *next;
	char dns_ifnames[64],cmdline[128]; */
	
	if (nvram_match("router_disable", "1") || nvram_match("router_disable_auto", "1"))
		return 0;
	
	/* Create resolv.conf with empty nameserver list if lan_ipaddr is same as lan_dns */
	if (!strcmp(nvram_safe_get("lan_dns"), nvram_safe_get("lan_ipaddr"))) {
		if (!(fp = fopen("/tmp/resolv.conf", "w"))) {
			perror("/tmp/resolv.conf");
			return errno;
		}
		fclose(fp);
	}
	/* not used yet
	// Setup interface list for the dns relay 
	 
	snprintf(dns_ifnames,sizeof(dns_ifnames),"-i %s",nvram_safe_get("lan_ifname"));
		
	foreach(word, nvram_safe_get("unbridged_ifnames"), next){ 
		if ( get_ipconfig_index(word) < 0 ) continue;
		
		// Check that the interface is truly up otherwise dnsmasq will 
		//  fail to start. Sometimes this can happen if the virtual interfaces
		//  come up but are not fully functional 
		 
		 
		if (ifconfig(word, IFUP, NULL, NULL)) continue; 
		snprintf(dns_ifnames,sizeof(dns_ifnames),"%s -i %s",dns_ifnames, word);		
	}
	
	// Start the dns relay 
	snprintf(cmdline,sizeof(cmdline),"/usr/sbin/dnsmasq -h -n %s -r /tmp/resolv.conf",dns_ifnames);
	ret = system(cmdline);
	*/
	
	/* launch dns relay */
	ret = eval("dnsmasq", "-h", "-n",
		   "-i", nvram_safe_get("lan_ifname"),
		   "-r", "/tmp/resolv.conf");

	dprintf("done\n");
	return ret;
}	

int
stop_dns(void)
{
	int ret = eval("killall", "dnsmasq");
	
	/* Remove resolv.conf */
	unlink("/tmp/resolv.conf");

	dprintf("done\n");
	return ret;
}	

int
start_httpd(void)
{
	int ret;

	chdir("/www");
	ret = eval("httpd");
	chdir("/");

	dprintf("done\n");
	return ret;
}

int
stop_httpd(void)
{
	int ret = eval("killall", "httpd");

	dprintf("done\n");
	return ret;
}


#ifdef __CONFIG_NAT__
#ifndef ROUTERG
int
start_upnp(void)
{
	char *wan_ifname;
	int ret;
	char var[100], prefix[] = "wanXXXXXXXXXX_";
	
	if (!nvram_invmatch("upnp_enable", "0"))
		return 0;
	
	ret = eval("killall", "-SIGUSR1", "upnp");
	if (ret != 0) {
	    snprintf(prefix, sizeof(prefix), "wan%d_", wan_primary_ifunit());
	    wan_ifname = nvram_match(strcat_r(prefix, "proto", var), "pppoe") ? 
					nvram_safe_get(strcat_r(prefix, "pppoe_ifname", var)) :
					nvram_safe_get(strcat_r(prefix, "ifname", var));
	    ret = eval("upnp", "-D",
		       "-L", nvram_safe_get("lan_ifname"),
		       "-W", wan_ifname);

	}
	
	dprintf("done\n");
	return ret;
}

int
stop_upnp(void)
{
	int ret = 0;

	if (nvram_match("upnp_enable", "1"))
	    ret = eval("killall", "upnp");

	dprintf("done\n");
	return ret;
}

#ifndef AP_CR
int
start_ippd(void)
{	
	FILE *fp;
  	int ret;
	char *ippName = "My_Printer";
	char *ippMake = "My_Printer";
	char *device = "/dev/usb/lp0";
	pid_t pid;
	char *argv[] = {"ippd", NULL};
	
	chdir("/var");
	//printf("ippName: %s, ippMake: %s, device: %s\n", ippName, ippMake, device);
	if(( fp = fopen( "/var/printers.ini", "w") ) == NULL ){
		perror("/var/printers.ini");
		return errno;
	}
      	fprintf( fp, "[%s]\nmake=%s\ndevice=%s\n", ippName, ippMake, device);
    	fclose( fp );

	ret = _eval(argv, NULL, 0, &pid);
	chdir("/");
  		
	dprintf("done\n");
	
	return ret;
}

int
stop_ippd(void)
{
	int ret = eval("killall", "ippd");

	dprintf("done\n");
	return ret;
}
#endif /* AP_CR */
#endif /* ROUTERG */
#endif	/* __CONFIG_NAT__ */

#ifdef NPHY
int
start_ses(void)
{
	if (nvram_match("ses_enable", "1")) {
		eval("ses", "-f");
	}

	return 0;
}

int
stop_ses(void)
{
	int ret = 0;

	ret = eval("killall", "ses");

	return ret;
}

int
start_ses_cl(void)
{
	if (nvram_match("ses_cl_enable", "1")) {
		eval("ses_cl", "-f");
	}

	return 0;
}

int
stop_ses_cl(void)
{
	int ret = 0;

	ret = eval("killall", "ses_cl");

	return ret;
}
#endif /* NPHY */

int
start_nas(char *type)
{
	char cfgfile[64];
	char pidfile[64];
	if (!type || !*type)
		type = "lan";
	/* Configure NAS on the bridged interface */
	snprintf(cfgfile, sizeof(cfgfile), "/tmp/nas.%s.conf", type);
	snprintf(pidfile, sizeof(pidfile), "/tmp/nas.%s.pid", type);
	{
		char *argv[] = {"nas", cfgfile, pidfile, type, NULL};
		pid_t pid;

		_eval(argv, NULL, 0, &pid);
		dprintf("done\n");
	}
	
	return 0;
}
/* not used yet
// Start NAS for the guest interfaces
int
start_guest_nas(void)
{
	char *unbridged_interfaces;
	char *next;
	char name[IFNAMSIZ],lan[IFNAMSIZ];
	int index;
		
	unbridged_interfaces = nvram_get("unbridged_ifnames");
	
	if (unbridged_interfaces)
		foreach(name,unbridged_interfaces,next){
			index = get_ipconfig_index(name);
			if (index < 0) 
				continue;
			snprintf(lan,sizeof(lan),"lan%d",index);
			start_nas(lan);
		}

	return 0;
}
*/

int
stop_nas(void)
{
	int ret = eval("killall", "nas");

	dprintf("done\n");
	return ret;
}

int
start_ntpc(void)
{
	char *servers = nvram_safe_get("ntp_server");
	
	if (strlen(servers)) {
		char *nas_argv[] = {"ntpclient", "-h", servers, "-i", "3", "-l", "-s", NULL};
		pid_t pid;

		_eval(nas_argv, NULL, 0, &pid);
	}
	
	dprintf("done\n");
	return 0;
}

int
stop_ntpc(void)
{
	int ret = eval("killall", "ntpclient");

	dprintf("done\n");
	return ret;
}
#ifdef __CONFIG_UTELNETD__
int
start_telnet(void)
{
   	int ret;
  	 ret = eval("utelnetd", "-d", "-i", 
   		nvram_safe_get("lan_ifname"));
   	return ret;
}

int
stop_telnet(void)
{
   	int ret;
   	ret = eval("killall","utelnetd");
   	return ret;
}
#endif /* __CONFIG_UTELNETD__ */

#ifdef __CONFIG_LLD2D__
int start_lltd(void)
{
	chdir("/usr/sbin");
	eval("lld2d", "br0");
	chdir("/");
	
	return 0;
}

int stop_lltd(void)
{
	int ret;
	
	ret = eval("killall", "lld2d");

	return ret;
}
#endif /* __CONFIG_LLD2D__ */

#ifdef CR
int
start_wsc(void)
{

	if((!nvram_match("wsc_cli","1")) && nvram_match("wsc_mode","enabled"))
	{
		if (nvram_match("is_default", "1")) {
			/* generate a new WPS PIN */
			unsigned long PIN;
			unsigned long int accum = 0;
			int digit, i;
			char devPwd[32];
			char temp[20], temp1[20];
			int j = 0;
									
			strcpy(temp, nvram_safe_get("et0macaddr"));
			for(i = 16; i >= 0; i--) {
				if (temp[i] != ':') {
					temp1[j] = temp[i];
					j++;
				}
			}
			temp1[7] = '\0';
			PIN  = (strtoul( temp1, NULL, 16 ));
			if (PIN < 100000000)
				PIN += 123456799;
			PIN *= 0.937542361;
			cprintf("PIN is %u\n", PIN);
			sprintf( devPwd, "%09u", PIN );
			devPwd[8] = '\0';
			if (devPwd[1] == '0')
				devPwd[1] = '1';

			PIN = strtoul( &devPwd[1], NULL, 10 );

			PIN *= 10;
			accum += 3 * ((PIN / 10000000) % 10); 
			accum += 1 * ((PIN / 1000000) % 10); 
			accum += 3 * ((PIN / 100000) % 10); 
			accum += 1 * ((PIN / 10000) % 10); 
			accum += 3 * ((PIN / 1000) % 10); 
			accum += 1 * ((PIN / 100) % 10); 
			accum += 3 * ((PIN / 10) % 10); 

			digit = (accum % 10);
			accum = (10 - digit) % 10;

			PIN += accum;
			sprintf( devPwd, "%u", PIN );
			devPwd[8] = '\0';

			cprintf("Setup: Generate WPS PIN = %s\n", devPwd);
			nvram_set("wsc_device_pin", devPwd);
			nvram_set("wsc_method", "1"); //choose PIN method
			/* generate uuid */
			typedef unsigned char u_int8;
    			char str[50];
			static int uuid_count = 0;
   			u_int d[16];
    			
				
			sscanf(nvram_safe_get("et0macaddr"), "%x:%x:%x:%x:%x:%x",
	       			&d[0], &d[1], &d[2], &d[3], &d[4], &d[5]);
   			sscanf(nvram_safe_get("et0macaddr"), "%x:%x:%x:%x:%x:%x",
	   			&d[6], &d[7], &d[8], &d[9], &d[10], &d[11]);
    			*((int *)&d[12]) = uuid_count++;

			snprintf(str, sizeof(str), "0x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
    	    			(u_int8)d[0], (u_int8)d[1], (u_int8)d[2], (u_int8)d[3], (u_int8)d[4], (u_int8)d[5], (u_int8)d[6], (u_int8)d[7], 
    	    			(u_int8)d[8], (u_int8)d[9], (u_int8)d[10], (u_int8)d[11], (u_int8)d[12], (u_int8)d[13], (u_int8)d[14], (u_int8)d[15]);
			cprintf("Setup: Generate wsc_uuid = %s\n", str);
			nvram_set("wsc_uuid", str);
		}
		
		if (nvram_match("wsc_restart", "no")) {

			nvram_set("wsc_restart", "normal");
		}
		else
		{
			char *wsc_argv[] = {"/bin/wsccmd", NULL};
			pid_t pid;

			cprintf("Starting wsc\n");
			nvram_set("wsc_restart", "yes");
			_eval(wsc_argv, NULL, 0, &pid);
			sleep(5);
		}
		if (nvram_match("is_default", "1"))
			nvram_set("wsc_config_command", "1"); //start geting configuration from ER
		//if AP not Configured and addER enabled, start adding ER usin PIN method.
		else if ((nvram_match( "wsc_config_state", "0" )) || 
		   	(nvram_match( "wsc_addER", "1" )))
		{
			nvram_set("wsc_proc_status", "0");
			nvram_set("wsc_config_command", "1");
		}
	}
	return 0;
}

int
stop_wsc(void)
{
   	int ret;

	//if((!nvram_match("wsc_cli","1")) && nvram_match("wl_wsc_mode","enabled"))
	if(!nvram_match("wsc_cli","1"))
	{
		if (nvram_match("wsc_restart", "no")) {
			return 0;
		}
		else
		{
			nvram_set("wsc_restart", "yes");
		   	ret = eval("killall","wsccmd");
		}
	}
   	return ret;
}
#endif	/* CR */

int
start_services(void)
{
	start_httpd();
	start_dns();
#ifdef CLIENT
	if (nvram_match("router_disable", "0"))
		start_dhcpd();
#endif
#ifdef __CONFIG_NAT__
	start_dhcpd();
#ifndef ROUTERG
#ifndef AP_CR	
	start_ippd();
#endif	/* AP-CR */	
	start_upnp();
#endif	/* ROUTERG */
#endif	/* __CONFIG_NAT__ */
	start_nas("lan");
	/*not used yet
	start_guest_nas();
	*/ 
#ifdef NPHY
	start_ses();
	start_ses_cl();
#endif
#ifdef __CONFIG_UTELNETD__
	start_telnet();
#endif
#ifdef __CONFIG_LLD2D__
	start_lltd();
#endif /* __CONFIG_LLD2D__*/
	dprintf("done\n");
	return 0;
}

int
stop_services(void)
{
#ifdef NPHY
	stop_ses();
	stop_ses_cl();
#endif
	stop_nas();
#ifdef __CONFIG_NAT__
#ifndef ROUTERG	
	stop_upnp();
#endif	/* ROUTERG */
#ifndef AP_CR
#ifndef ROUTERG
	stop_ippd();
#endif	/* ROUTERG */
	stop_pptp();
#endif	/* AP_CR */	
	stop_dhcpd();
#endif	/* __CONFIG_NAT__ */
#ifdef CLIENT
	if (nvram_match("router_disable", "0"))
		stop_dhcpd();
#endif /* CLIENT */
	stop_dns();
	stop_httpd();
#ifdef __CONFIG_UTELNETD__
	stop_telnet();
#endif
#ifdef __CONFIG_LLD2D__
	stop_lltd();
#endif 	/* __CONFIG_LLD2D__*/

	dprintf("done\n");
	return 0;
}
