<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--
Copyright 2004-2007, U.S. Robotics Corporation
All Rights Reserved.

THIS SOFTWARE IS OFFERED "AS IS", AND U.S. Robotics GRANTS NO WARRANTIES OF ANY
KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. U.S. Robotics
SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
-->
<html lang="en">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<title>Add Wireless Device :: USRobotics Wireless MAXg Access Point</title>
	<link href="main.css" rel="stylesheet" type="text/css">
	<script type="text/javascript" src="5451.js"></script>
	<script type="text/javascript" src="common.js"></script>
	<script type="text/javascript" src="prototype.js"></script>
	<script type="text/javascript">
<!--
/* get the right WEP wireless key */
function get_key()
{
	var idx = <% nvram_get("wl0_key"); %>;
	if (idx == 1)
		return "<% nvram_get("wl0_key1"); %>";
	if (idx == 2)
		return "<% nvram_get("wl0_key2"); %>";
	if (idx == 3)
		return "<% nvram_get("wl0_key3"); %>";
	if (idx == 4)
		return "<% nvram_get("wl0_key4"); %>";
}

function getKeyType()
{
	var key = get_key();
	var size = getKeySize(key);

	if (isKeyASCII(key))
	{
		if (size == 128)
			return "128-bit ASCII";
		if (size == 64)
			return "64-bit ASCII";
	}
	else
	{
		if (size == 128)
			return "128-bit hex";
		if (size == 64)
			return "64-bit hex";
	}
}

function get_encryption()
{
	var encrypt = "<% nvram_get("cbEncryption"); %>";
	if (encrypt == "tkip+aes")
		return "TKIP and AES";
	if (encrypt == "aes")
		return "AES";
	if (encrypt == "tkip")
		return "TKIP";
	else
		return "";
}

function get_method()
{
	var auth = "<% nvram_get("cbAuthEncrypt"); %>";
	if (auth == "wpa12")
		return "WPA2 and WPA (PSK)";
	if (auth == "wpa2")
		return "WPA2 (PSK)";
	if (auth == "wpa")
		return "WPA (PSK)";
	if (auth == "open")
		return "WEP open";
	if (auth == "shared")
		return "WEP shared";
	if (auth == "none")
		return "None";
	if (auth == "radius-wpa12")
		return "WPA2 and WPA with 802.1x (RADIUS)";
	if (auth == "radius-wpa2")
		return "WPA2 with 802.1x (RADIUS)";
	if (auth == "radius-wpa")
		return "WPA with 802.1x (RADIUS)";
	else
		return "";
}

function get_authentication()
{
	var auth = "<% nvram_get("cbAuthEncrypt"); %>";
	if	((auth == "radius-wpa12") || (auth == "radius-wpa2") || (auth == "radius-wpa"))
		return "Enabled";
	else
		return "Disabled";
}

/* get wds restriction */
function get_wds()
{
	var wds = <% nvram_get("wl0_lazywds"); %>;
	return (wds ? "disabled" : "enabled");
}

/* initialize radius server and key encryption fields */
window.onload = function()
{
	/*
		If WPS isn't running or we're not configured or an external
		registrar is being used, disable the WPS features.
	*/
	var bWPS = ("<% nvram_get("wl_wsc_mode"); %>" == "enabled");	// "enabled" or "disabled"
	var bInternalRegistrar = ("<% nvram_get("wl_wsc_reg"); %>" == "enabled");	// "enabled" or "disabled"
	var bConfigured = ("<% nvram_get("wsc_config_state"); %>" == "1");	// "0" or "1"
	if (!bWPS || !bInternalRegistrar || !bConfigured)
		$("idWPSsection").hide();

	var auth = "<% nvram_get("cbAuthEncrypt"); %>";
	var filter = "<% nvram_get("wl0_macmode"); %>";
	var ssid = <% nvram_get("wl0_closed"); %>;
	if ((auth == "wpa12") || (auth == "wpa2") || (auth == "wpa"))
		$("idEncrypt", "idKey1", "idWPA").invoke("show");
	else if ((auth == "open") || (auth == "shared"))
		$("idKey2", "idWEP").invoke("show");
	else if (auth == "none")
		setVisibility('idNone', true);
	else if	((auth == "radius-wpa12") || (auth == "radius-wpa2") || (auth == "radius-wpa"))
		$("idEncrypt", "idRadiusserver", "idRadiusport", "idRadiuskey", "idAuthentication").invoke("show");

	if (filter == "allow")
		$("idMACallow", "idMACfiltering", "idMACallow1", "idMACallow2").invoke("show");
	else if (filter == "deny")
		$("idMACdeny", "idMACfiltering", "idMACdeny1", "idMACdeny2").invoke("show");

	if (ssid)
		setVisibility('idBroadcastOff', true);
	else
		setVisibility('idBroadcastOn', true);

//Now that MAC filtering is at the beginning, we can't do
//this--it scrolls the page so the element is visible.
//	$("idFormWPSpush").focusFirstElement();
}
//-->
</script>
<style>
.clsResults {}
</style>
</head>

<body>
<script type="text/javascript">
	writeHeader("Add Wireless Device");
</script>

<p>There are a few ways to add a wireless device to your network.
Which one you use depends on what the wireless device supports.
If the wireless device doesn't support WPS,
you will enter the access point's security information into the device yourself.

<div id="idMACfiltering" style="display: none;">
<h4>MAC Filtering</h4>

	<div id="idMACallow1" style="display: none;">
	<p>Since this access point has MAC filtering enabled and is allowing only certain
	wireless devices to connect, you need to ensure that the device's
	MAC address is permitted to connect to the access point.</p>
	<p>One way to do this is to turn off MAC filtering and configure the
	device to connect to the access point. After that's completed, you can use
	the access point's <strong>Allow Current Clients</strong> feature to
	automatically add the client to the list of allowed devices and re-enable MAC filtering.</p>
	</div>

	<p id="idMACdeny1" style="display: none;">
	Since this access point has MAC filtering enabled and is denying certain wireless
	devices the ability to connect, you need to ensure that the device's
	MAC address is not in the list of devices to be denied.</p>

<p>A MAC address is a set of six bytes typically separated by colons or dashes or spaces.
(A byte consists of two hexadecimal digits&mdash;0-9 and A-F.)
For example: &ldquo;<label>00:C0:49:AA:22:43</label>.&rdquo;</p>

<p>These are some ways you may be able to determine the device's MAC address:
<ul>
	<li>The MAC address is typically displayed on the device itself or on the device's packaging.</li>
	<li>If the device is running Windows Vista, XP, 2000, or NT and you're familiar with the command prompt,
	you can use the &ldquo;ipconfig /all&rdquo; command to display the MAC address.</li>
	<li>If the device is running Windows Me, 98, or 95 and you're familiar with the command prompt,
	you can use the &ldquo;winipcfg&rdquo; command to display the MAC address.</li>
	<li>The device's wireless configuration utility typically displays the MAC address somewhere.</li>
</ul>
</p>

<p>Use the <a href="security.asp">Security</a> page to configure MAC filtering.</p>
</div>


<div id="idWPSsection">
<h3>Wi-Fi Protected Setup (WPS)</h3>

<p>
WPS devices use a push button or PIN to connect to the network.
See your wireless device's documentation to determine
if it can connect to the access point using WPS,
which method you should use to connect to the access point,
and how to locate the push button or PIN for the device.
</p>

<form id="idFormWPSpush" action="">
<fieldset><legend>Add Device with WPS Push Button</legend>
	<p>If you have a wireless device that supports a WPS push button,
	you can add it to the network by pressing <b>Find Device</b>.</p>

	<input type="hidden" name="action" value="2"/>
	<input type="submit" value=" Find Device " id="btnWPSpush"/>
	<p id="idPushResults" class="clsResults"/>
</fieldset>
</form>

<form id="idFormWPSadd" action="">
<fieldset><legend>Add Device with WPS PIN</legend>
	<p>If you have a wireless device that supports a WPS PIN, you can
	add it to the network by entering its PIN and pressing <b>Add Device</b>.</p>

	<input type="hidden" name="action" value="1"/>
	<label for="wsc_sta_pin">PIN:</label>
	<input type="text" id="wsc_sta_pin" name="wsc_sta_pin" value="" maxlength="8" size="10"/>
	<input type="submit" value=" Add Device " id="btnWPSAdd"/>
	<p id="idAddResults" class="clsResults"/>
</fieldset>
</form>


<script type="text/javascript">
/*
	WPS Add Device with Pushbutton
*/
$("idFormWPSpush").onsubmit = wpsAddClient;
/*
	WPS Add Device with PIN
*/
$("idFormWPSadd").onsubmit = wpsAddClient;

function wpsAddClient()
{
	var action = new WPSAction($("idFormWPSpush", "idFormWPSadd"), this.down(".clsResults"));
	new Ajax.Request("wps.cgi",
							{
								method:		"post",
								parameters:	this.serialize(true /*return hash*/),
								onSuccess:	action._onOK_WPSaddclient.bind(action),
								onFailure:	action._onBad_WPSaddclient.bind(action)
							});

	action.eltInput.invoke("disable");
	return false;
}

/*
	The WPS pushbutton or WPS Add PIN has been activated.
	Now poll for results.
	Stop when done.
*/
var WPSAction = new Class.create();
WPSAction.prototype =
{
	initialize: function(eltInput, strIDStatus)
	{
		this.strIDStatus = strIDStatus;	// id of status container
		this.eltInput = eltInput;			// array of elements--forms--to enable when done
		this.myTimer = null;
	},

	_onOK_WPSaddclient: function(xhr)
	{
		var obj = getResponseText(xhr);
		if (obj == null)
			return;

		if ((obj.validpin != undefined) && !obj.validpin)
		{
			$(this.strIDStatus).update("The PIN is invalid. Please confirm the device's PIN and try again.");
			this._doneWaiting();
			return;
		}

		// Display something for the first 3 seconds
		$(this.strIDStatus).update("Initializing&hellip;");
		this.myTimer = new PeriodicalExecuter(this._timerWPSpoll.bind(this), 3);	// every 3s
	},

	_timerWPSpoll: function(objPE)
	{
		new Ajax.Request("getvar.cgi",
								{
									parameters:	{ name: "wsc_proc_status" },
									onSuccess:	this._onOK_WPSstatus.bind(this)
								});
	},

	_onBad_WPSaddclient: function(xhr)
	{
		$(this.strIDStatus).update("Unable to complete request.");
		this._doneWaiting();
	},

	/*
		1:	Processing WPS start
		2: Success (stop)
		3: Fail due to WPS msg exchange error (stop)
		4: Fail due to WPS timeout (stop)
		?: Initializing

		{
			state:	1;
		}
	*/
	_onOK_WPSstatus: function(xhr)
	{
		var obj = getResponseText(xhr);
		if (obj == null)
			return;

		// obj.name == "wsc_proc_status"

		switch (obj.value)
		{
			case "1":
				$(this.strIDStatus).update("Searching&hellip;");
				break;

			case "2":
				$(this.strIDStatus).update("Device added to your wireless network.");
				this._doneWaiting();
				break;

			case "3":
				$(this.strIDStatus).update("Communication error.");
				this._doneWaiting();
				break;

			case "4":
				$(this.strIDStatus).update("Unable to find device. Please ensure the device is in range, start WPS on the device, and try again.");
				this._doneWaiting();
				break;

			default:
				$(this.strIDStatus).update("Initializing&hellip;");
				break;
		}
	},

	_doneWaiting: function()
	{
		if (this.myTimer != null)
		{
			this.myTimer.stop();
			this.myTimer = null;
		}
		this.eltInput.invoke("enable");
	}
};
</script>
</div>


<h3>Manual Configuration</h3>

<p>If your wireless device does not support WPS, you can enter the necessary
security information manually.
The access point may provide some of this information to the device automatically,
but if it doesn't, you will have to enter it.</p>

<p>When you install a wireless adapter in a computer running Windows,
it usually comes with a utility that is installed on the computer and
displays an icon in the taskbar's notification area.
Windows&nbsp;XP also provides its own mechanism for managing wireless adapters.
One thing all wireless devices have in common is that they have some way to
configure the wireless connection.</p>

<p>Although there are many different wireless devices, they use almost identical
terms for the information they require to establish a wireless connection.</p>

<div id="idPanelHelp">
	<h1>Device Reference Sheet</h1>

	<table border="0">
		<tr>
			<td><label>Network&nbsp;name:</label></td>
			<td class="clsStatic"><% nvram_get("wl0_ssid"); %></td>
		</tr>
		<tr>
			<td><label>Method:</label></td>
			<td class="clsStatic"><script type="text/javascript">document.write(get_method());</script></td>
		</tr>
		<tr id="idEncrypt" style="display: none;">
			<td><label>Encryption:</label></td>
			<td class="clsStatic"><script type="text/javascript">document.write(get_encryption());</script></td>
		</tr>
		<tr id="idKey1" style="display: none;">
			<td><label>Pass phrase:</label></td>
			<td class="clsStatic"><% nvram_get("wl0_wpa_psk"); %></td>
		</tr>
		<tr id="idKey2" style="display: none;">
			<td><label>Key:</label></td>
			<td class="clsStatic"><script>document.write(get_key());</script></td>
		</tr>
		<tr id="idRadiusserver" style="display: none;">
			<td><label>RADIUS server:</label></td>
			<td class="clsStatic"><% nvram_get("wl0_radius_ipaddr"); %></td>
		</tr>
		<tr id="idRadiusport" style="display: none;">
			<td><label>RADIUS port:</label></td>
			<td class="clsStatic"><% nvram_get("wl0_radius_port"); %></td>
		</tr>
		<tr id="idRadiuskey" style="display: none;">
			<td><label>RADIUS key:</label></td>
			<td class="clsStatic"><% nvram_get("wl0_radius_key"); %></td>
		</tr>
	</table>

	<p id="idMACallow" style="display: none;">MAC filtering is allowing only specified devices.</p>
	<p id="idMACdeny" style="display: none;">MAC filtering is denying only specified devices.</p>
</div>


<h4>1. Network name (SSID)</h4>

<p>The first thing a wireless device needs to know is the network name or SSID,
which is set on the access point.</p>

<p>The network name of this access point is <span class="clsHighlight"><% nvram_get("wl0_ssid"); %></span>.</p>

<p id="idBroadcastOn" style="display: none;">Since the access point is broadcasting its network name, you don't have to
enter it into the wireless device's utility. You should be able to perform a
&ldquo;site survey&rdquo; or &ldquo;scan&rdquo; and the utility will indicate that
it's found the access point's network name.</p>

<p id="idBroadcastOff" style="display: none;">
The access point is not broadcasting its network name, so you will need to enter it
into the wireless device's utility. Most utilities are different, but
there is usually a mechanism for creating a &ldquo;profile&rdquo; and entering
the necessary information.</p>


<h4>2. Security</h4>

<p>In order for a wireless device to communicate with an access point using security,
it must use the same method.
Security for wireless communication consists of an authentication method (which controls
which devices can connect to the access point) and an encryption method (which prevents someone from
&ldquo;reading&rdquo; the data being sent between a wireless device and the access point).</p>

	<p id="idWPA" style="display: none;">The access point's authentication method is <span class="clsHighlight"><script type="text/javascript">document.write(get_method());</script></span>.
	The encryption method is <span class="clsHighlight"><script type="text/javascript">document.write(get_encryption());</script></span>
	and the encryption key is <span class="clsHighlight"><% nvram_get("wl0_wpa_psk"); %></span>.</p>

	<p id="idWEP" style="display: none;">The access point's authentication method is <span class="clsHighlight"><script type="text/javascript">document.write(get_method());</script></span>.
	The encryption method is <span class="clsHighlight">WEP</span> and the encryption key is
	<span class="clsHighlight"><script>document.write(get_key());</script></span>.
	You may also need to select the type of key, which is <span class="clsHighlight"><script>document.write(getKeyType());</script></span>.</p>

	<p id="idAuthentication" style="display: none;">The access point's authentication method is <span class="clsHighlight"><script type="text/javascript">document.write(get_method());</script></span>;
	the encryption method is <span class="clsHighlight"><script type="text/javascript">document.write(get_encryption());</script></span>;
	the RADIUS server is <span class="clsHighlight"><% nvram_get("wl0_radius_ipaddr"); %></span>; the RADIUS port is <span class="clsHighlight"><% nvram_get("wl0_radius_port"); %></span>;
	the RADIUS key is <span class="clsHighlight"><% nvram_get("wl0_radius_key"); %></span>.</p>

	<p id="idNone" style="display: none;">
	The access point is insecure, so the device may already be able to connect to it.</p>


<h3>Troubleshooting</h3>

<p>If a wireless device cannot connect, the wrong encryption method may be
selected or the key may be entered incorrectly.
Double-check the device's wireless configuration utility to ensure
you've entered everything correctly.
Make sure the wireless device has &ldquo;Infrastructure&rdquo; selected as the network type.
</p>

<p>You should also make certain that the access point and device are positioned so that their
transmissions can reach each other.
If possible, try to configure them when they are positioned next to each other.</p>

	<p id="idMACallow2" style="display: none;">Since this access point has <span class="clsHighlight">MAC filtering configured to allow only certain devices</span>
	to connect, the device's MAC address might not be in the list of
	devices permitted to connect to the access point.
	You can configure MAC filtering on the <a href="security.asp">Security</a> page.</p>

	<p id="idMACdeny2" style="display: none;">
	Since this access point has <span class="clsHighlight">MAC filtering configured to deny certain devices</span>, the
	device's MAC address might be in the list of devices to be denied.
	You can configure MAC filtering on the <a href="security.asp">Security</a> page.</p>

<p class="clsNote"><a href="status.asp">Back to the Status page</a></p>

<script type="text/javascript">
	writeCopyright();
</script>

</body>
</html>
