/* 
Copyright 2004-2007, U.S. Robotics Corporation
All Rights Reserved.

THIS SOFTWARE IS OFFERED "AS IS", AND U.S. Robotics GRANTS NO WARRANTIES OF ANY
KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. U.S. Robotics
SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
*/
function ConvertSecondsToHH(secs)
{	var hr = Math.floor(secs / 3600);
	var ampm = (hr >= 12 ? "PM" : "AM");
	hr %= 12;
	if (hr == 0)
		hr = 12;
	return hr + ampm;
}
function initWeekdays(elt)
{   for (ix = 0; ix < 7; ++ix)
		elt.options[ix] = new Option(WeekdayName(ix), ix);
   elt.options[0].selected = true;
}
function initHours(elt)
{  for (i = 0; i < 24; ++i)
   {
   	var s = "";
   	if (i == 0)
   		s = "12AM";
   	else if (i == 12)
   		s = "12PM";
   	else if (i > 12)
   		s = (i % 12) + "PM";
		else
   		s = i + "AM";
	if (i == 0)	
		elt.options[i] = new Option(s, 1);
	else
		elt.options[i] = new Option(s, i * 3600);
   }
	elt.options[0].selected = true;
}
function initHours1(elt)
{  for (i = 0; i < 24; ++i)
   {   	var s = "";
   	if (i == 0)
   		s = "12AM";
   	else if (i == 12)
   		s = "12PM";
   	else if (i > 12)
   		s = (i % 12) + "PM";
		else
   		s = i + "AM";
	if (i == 0)	
		elt.options[i] = new Option(s, 2);
	else
		elt.options[i] = new Option(s, (i * 3600 + 1));
   }
	elt.options[0].selected = true;
}
function initComboboxes()
{	initWeekdays(document.idForm.cbWeekdayFrom);
	initWeekdays(document.idForm.cbWeekdayTo);
	initHours1(document.idForm.cbTimeFrom);
	initHours(document.idForm.cbTimeTo);
}
function updateTo(srcA, srcB, destA, destB)
{	var eltSrcA = document.getElementById(srcA);
	var eltSrcB = document.getElementById(srcB);
	var eltDestA = document.getElementById(destA);
	var eltDestB = document.getElementById(destB);
	var s = parseInt(eltDestA.value) + (parseInt(eltSrcB.value) - parseInt(eltSrcA.value));
	if (isNaN(s) || (s < 0))
		s = "";
      	eltDestB.value = s;
}
function tableDeleteRowFirewall(objTable, ixRow, strIDnotice)
{	tableDeleteRow(objTable, ixRow);
	setVisibility(strIDnotice, true);
}
var reIPaddress = "((?:\\d{1,3}\.){3}\\d{1,3})";
var rePort = "(\\d{1,5})";
var rePortRange = rePort + "-" + rePort;
var reHour = "(\\d{1,5})";
var reProtocol = "(.*?)";
function fctFormatRowIAC(objTable, row)
{	var aRow = objTable.aRows[row];
	var strHTML = "<tr valign=\"top\">";
	strHTML += "<td><input type=\"checkbox\"" + (aRow[0] == "on" ? " checked" : "") + " onclick=\"tableModifyValue(" + objTable.strThis + ", " + row + ", 0);\">";
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[0] + row + "\" value=\"" + aRow[0] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += aRow[1] + "<br/>to<br/>" + aRow[2];
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[1] + row + "\" value=\"" + aRow[1] + "\">";
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[2] + row + "\" value=\"" + aRow[2] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += aRow[3].toUpperCase();
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[3] + row + "\" value=\"" + aRow[3] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += aRow[4] + "<br/>to<br/>" + aRow[5];
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[4] + row + "\" value=\"" + aRow[4] + "\">";
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[5] + row + "\" value=\"" + aRow[5] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += WeekdayName(parseInt(aRow[6])) + "<br/>to<br/>" + WeekdayName(parseInt(aRow[7]));
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[6] + row + "\" value=\"" + aRow[6] + "\">";
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[7] + row + "\" value=\"" + aRow[7] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += ConvertSecondsToHH(aRow[8]) + "<br/>to<br/>" + ConvertSecondsToHH(aRow[9]);
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[8] + row + "\" value=\"" + aRow[8] + "\">";
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[9] + row + "\" value=\"" + aRow[9] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td>";
	strHTML += "<input type=\"button\" value=\"Delete\" class=\"clsSmall\" onclick=\"tableDeleteRowFirewall(" + objTable.strThis + ", " + row + ", 'idChangesIAC');\">";
	strHTML += "<\/td>";
	strHTML += "<\/tr>";
	return strHTML;
}
function tableAddRowIAC()
{	var aRowNew = new Array(	"on",
					document.idForm.txtIACIPfrom.value,
					document.idForm.txtIACIPto.value,
					document.idForm.cbIACprotocol.value,
					document.idForm.txtPortFrom.value,
					document.idForm.txtPortTo.value,
					document.idForm.cbWeekdayFrom.value,
					document.idForm.cbWeekdayTo.value,
					document.idForm.cbTimeFrom.value,
					document.idForm.cbTimeTo.value
				);
	if (validateDataIAC(aRowNew) && !tableIsDuplicateRow(objTableIAC, aRowNew))
	{	tableAddRow(objTableIAC, aRowNew);
		setVisibility("idChangesIAC", true);
	}
}
function validateDataIAC(aRow)
{	var strField = "";
	if (aRow[1] == "")
		strField = "the start of the IP Address range";
	else if (aRow[2] == "")
		strField = "the end of the IP Address range";
	else if (aRow[3] == "")
		strField = "protocol";
	else if (aRow[4] == "")
		strField = "start of the port number range";
	else if (aRow[5] == "")
		strField = "end of the port number range";
	else if (aRow[6] == "")
		strField = "start of the weekday range";
	else if (aRow[7] == "")
		strField = "end of the weekday range";
	else if (aRow[8] == "")
		strField = "start of the time range";
	else if (aRow[9] == "")
		strField = "end of the time range";
	var strMsg = "";
	if (strField == "")
	{	if (parseInt(aRow[4]) > parseInt(aRow[5]))
			strMsg = "The start of the port range must be less than or equal to the end.";
	}
	else
		strMsg = "Please enter a value for " + strField + ".";
	if (strMsg == "")
		return true;
	alert(strMsg);
	return false;
}
function fctFormatRowPT(objTable, row)
{	var aRow = objTable.aRows[row];
	var strHTML = "<tr valign=\"top\">";
	strHTML += "<td><input type=\"checkbox\"" + (aRow[0] == "on" ? " checked" : "") + " onclick=\"tableModifyValue(" + objTable.strThis + ", " + row + ", 0);\">";
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[0] + row + "\" value=\"" + aRow[0] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += aRow[1].toUpperCase();
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[1] + row + "\" value=\"" + aRow[1] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += aRow[2] + "<br/>to<br/>" + aRow[3];
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[2] + row + "\" value=\"" + aRow[2] + "\">";
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[3] + row + "\" value=\"" + aRow[3] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += aRow[4].toUpperCase();
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[4] + row + "\" value=\"" + aRow[4] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += aRow[5] + "<br/>to<br/>" + aRow[6];
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[5] + row + "\" value=\"" + aRow[5] + "\">";
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[6] + row + "\" value=\"" + aRow[6] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += aRow[7] + "<br/>to<br/>" + aRow[8];
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[7] + row + "\" value=\"" + aRow[7] + "\">";
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[8] + row + "\" value=\"" + aRow[8] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td>";
	strHTML += "<input type=\"button\" value=\"Delete\" class=\"clsSmall\" onclick=\"tableDeleteRowFirewall(" + objTable.strThis + ", " + row + ", 'idChangesPT');\">";
	strHTML += "<\/td>";
	strHTML += "<\/tr>";
	return strHTML;
}
function tableAddRowPT()
{	var aRowNew = new Array(	"on",
					document.idForm.cbPTOutProtocol.value,
					document.idForm.txtPTOutPortFrom.value,
					document.idForm.txtPTOutPortTo.value,
					document.idForm.cbPTInProtocol.value,
					document.idForm.txtPTInPortFrom.value,
					document.idForm.txtPTInPortTo.value,
					document.idForm.txtPTDestPortFrom.value,
					document.idForm.txtPTDestPortTo.value
				);
	if (validateDataPT(aRowNew) && !tableIsDuplicateRow(objTablePT, aRowNew))
	{	tableAddRow(objTablePT, aRowNew);
		setVisibility("idChangesPT", true);
	}
}
function validateDataPT(aRow)
{	var strField = "";
	if (aRow[1] == "")
		strField = "inbound protocol";
	else if (aRow[2] == "")
		strField = "the start of the inbound port range";
	else if (aRow[3] == "")
		strField = "the end of the inbound port range";
	else if (aRow[4] == "")
		strField = "outbound protocol";
	else if (aRow[5] == "")
		strField = "start of the outbound port range";
	else if (aRow[6] == "")
		strField = "end of the outbound port range";
	else if (aRow[7] == "")
		strField = "start of the destination port range";
	else if (aRow[8] == "")
		strField = "end of the destination port range";
	var strMsg = "";
	if (strField == "")
	{	if (parseInt(aRow[2]) > parseInt(aRow[3]))
			strMsg = "The start of the inbound port range must be less than or equal to the end.";
		else if (parseInt(aRow[5]) > parseInt(aRow[6]))
			strMsg = "The start of the outbound port range must be less than or equal to the end.";
		else if (parseInt(aRow[7]) > parseInt(aRow[8]))
			strMsg = "The start of the destination port range must be less than or equal to the end.";
	}
	else
		strMsg = "Please enter a value for " + strField + ".";
	if (strMsg == "")
		return true;
	alert(strMsg);
	return false;
}
function fctFormatRowPF(objTable, row)
{	var aRow = objTable.aRows[row];
	var strHTML = "<tr valign=\"top\">";
	strHTML += "<td><input type=\"checkbox\"" + (aRow[0] == "on" ? " checked" : "") + " onclick=\"tableModifyValue(" + objTable.strThis + ", " + row + ", 0);\">";
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[0] + row + "\" value=\"" + aRow[0] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += aRow[1].toUpperCase();
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[1] + row + "\" value=\"" + aRow[1] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += aRow[2] + "<br/>to<br/>" + aRow[3];
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[2] + row + "\" value=\"" + aRow[2] + "\">";
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[3] + row + "\" value=\"" + aRow[3] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += aRow[4];
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[4] + row + "\" value=\"" + aRow[4] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += aRow[5] + "<br/>to<br/>" + aRow[6];
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[5] + row + "\" value=\"" + aRow[5] + "\">";
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[6] + row + "\" value=\"" + aRow[6] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td>";
	strHTML += "<input type=\"button\" value=\"Delete\" class=\"clsSmall\" onclick=\"tableDeleteRowFirewall(" + objTable.strThis + ", " + row + ", 'idChangesPF');\">";
	strHTML += "<\/td>";
	strHTML += "<\/tr>";
	return strHTML;
}
function tableAddRowPF()
{	var aRowNew = new Array(	"on",
					document.idForm.cbPFprotocol.value,
					document.idForm.txtWANportFrom.value,
					document.idForm.txtWANportTo.value,
					document.idForm.txtIP.value,
					document.idForm.txtLANportFrom.value,
					document.idForm.txtLANportTo.value
				);
	if (isNaN(parseInt(aRowNew[6])))
		aRowNew[6] = "";
	if (validateDataPF(aRowNew) && !tableIsDuplicateRow(objTablePF, aRowNew))
	{	tableAddRow(objTablePF, aRowNew);
		setVisibility("idChangesPF", true);
	}
}
function validateDataPF(aRow)
{	var strField = "";
	if (aRow[1] == "")
		strField = "protocol";
	else if (aRow[2] == "")
		strField = "the start of the WAN port range";
	else if (aRow[3] == "")
		strField = "the end of the WAN port range";
	else if (aRow[4] == "")
		strField = "LAN IP address";
	else if (aRow[5] == "")
		strField = "start of the LAN port range";
	else if (aRow[6] == "")
		strField = "end of the LAN port range";
	var strMsg = "";
	if (strField == "")
	{	if (parseInt(aRow[2]) > parseInt(aRow[3]))
			strMsg = "The start of the WAN port range must be less than or equal to the end.";
	}
	else
		strMsg = "Please enter a value for " + strField + ".";
	if (strMsg == "")
		return true;
	alert(strMsg);
	return false;
}
